<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xg="http://www.hyfinity.com/xgate" xmlns:xf="http://www.hyfinity.com/xfactory" xmlns:hyx="http://www.hyfinity.com/xengine" exclude-result-prefixes="xg hyx xf">
    <xsl:import href="hyfinity_com_skin_html.xsl"/>
    <xsl:output method="html" encoding="UTF-8" indent="yes"/>
    <xsl:template name="client_scripts">
        <!-- Import the Sarissa JavaScript files -->
        <script type="text/javascript" src="js/sarissa/sarissa.js"/>
        <script type="text/javascript" src="js/sarissa/sarissa_ieemu_xpath.js"/>
        <!-- Import the utility functions -->
        <script type="text/javascript" src="js/deploy.js">blank</script>
        <script type="text/javascript" src="../xde/utils.js">blank</script>
        <script type="text/javascript" src="js/TooltipFunctions.js">blank</script>
        <script type="text/javascript" src="js/DisplayUtils.js">blank</script>
        <script type="text/javascript" src="js/namespaces/namespaces.js">blank</script>
        <!-- Import the Treeview manager script -->
        <script type="text/javascript" src="js/treeview.js">blank</script>
        <script type="text/javascript" src="js/InstanceTreeView.js">blank</script>
        <!-- Import the RuleMaker javascript object model -->
        <script type="text/javascript" src="js/RuleBaseViewer.js">blank</script>
        <script type="text/javascript" src="js/RuleViewer.js">blank</script>
        <script type="text/javascript" src="js/ResultViewer.js">blank</script>
        <script type="text/javascript" src="js/ParamViewer.js">blank</script>
        <script type="text/javascript" src="js/ConditionViewer.js">blank</script>
        <script type="text/javascript" src="js/ClauseViewer.js">blank</script>
        <script type="text/javascript" src="js/ClauseOperatorViewer.js">blank</script>
        <script type="text/javascript" src="js/Toolbar.js">blank</script>
        <!-- Import the RuleBase Validation scripts -->
        <script type="text/javascript" src="js/validation/RuleBaseValidator.js">blank</script>
        <script type="text/javascript" src="js/validation/ValidationError.js">blank</script>
        <script type="text/javascript" src="js/dragdrop.js">blank</script>
        <!-- Import the Clipboard JavaScript files-->
        <script type="text/javascript" src="js/clipboardUtils.js">blank</script>
        <script type="text/javascript" src="js/rulemakerClipboard.js">blank</script>


        <script type="text/javascript" src="edit_area/edit_area_full.js"><![CDATA[// include editarea script ]]></script>

        <link rel="stylesheet" type="text/css" href="css/rm2.css"/>
        <link rel="stylesheet" type="text/css" href="css/treeview.css"/>
        <style type="text/css">xml {display: none;}</style>
        <script type="text/javascript">
            <xsl:text disable-output-escaping="yes"><![CDATA[
        var rulebase2;
        var treeviewManager;
        var toolbar;

        function setTableHeight()
        {
            var requiredHeight = (document.documentElement.clientHeight - 204) + 'px';
            document.getElementById('pageTable').style.height = requiredHeight;
            document.getElementById('rulebase_container').style.height = requiredHeight;
            document.getElementById('input_tree').style.height = requiredHeight;
            document.getElementById('output_tree').style.height = requiredHeight;

            checkStyleMethodForRulesDisplay();
        }

        window.onload = function() {

            setTableHeight();
            window.onresize = setTableHeight;

            var logicsheet = new XMLSerializer().serializeToString(getXMLIsland("logicsheet_test"));
            rulebase2 = new RuleBase(document.getElementById("rulebase_container"), logicsheet, "rulebase2");
            var state = getXMLIsland("rulebaseState");
            if (state == null)
            {
                state = (new DOMParser()).parseFromString('<rulebase_state xmlns="http://www.hyfinity.com/xengine"><instances><input visible="false"/><output visible="false"/></instances><rules visible="true"/><rulebase_settings visible="false"/><workspace_settings visible="false"/><namespace_settings visible="false"/></rulebase_state>', "text/xml");
            }
            Sarissa.setXpathNamespaces(state, "xmlns:hy='http://www.hyfinity.com/xengine'");

            rulebase2.parseXML(state);

            var inputDoc = getXMLIsland("input_document_content");
            var inputDocString = inputDoc ? new XMLSerializer().serializeToString(inputDoc) : '';
            var outputDoc = getXMLIsland("output_document_content");
            var outputDocString = outputDoc ? new XMLSerializer().serializeToString(outputDoc) : '';

            treeviewManager = new InstanceTreeviewManager(inputDocString, "input_td", "divider_td",
                                                          outputDocString, "output_td", "divider2_td",
                                                          rulebase2, "treeviewManager", state);
            document.getElementById('input_td').onselectstart=new Function ("return false");
            document.getElementById('output_td').onselectstart=new Function ("return false");
            if (rulebase2.isCustom)
            {
                document.getElementById("toolbar_container").style.visibility = 'hidden';
                document.getElementById("toolbar_container").style.height = '30px';
            }
            else
            {
                toolbar = new Toolbar("toolbar");
                toolbar.show(document.getElementById("toolbar_container"));
            }
            moveBox = document.getElementById("xpathBox2");
            document.rulemaker.xml_processing.value = '<processing>';

            rulebase2.show(state);
            document.getElementById("pageTable").style.visibility = 'visible';
            checkStyleMethodForRulesDisplay();
        }

        function validate()
        {
            var rv = new RuleBaseValidator();
            var errors = rv.validateRuleBase(rulebase2, true);
            if (errors.length > 0)
            {
                alert("There are " + errors.length + " errors in the logicsheet.\nPlease correct them and try again.");
            }
        }

        function save()
        {
            var rv = new RuleBaseValidator();
            var errors = rv.validateRuleBase(rulebase2, true);
            if (errors.length > 0)
            {
                var saveAnyway = confirm("There are errors present in this file.  Do you wish to save anyway?");
                if (saveAnyway)
                {
                    doSave();
                }
            }
            else
            {
                doSave();
            }
        }

        function doSave()
        {
            document.rulemaker.xml_processing.value += '</processing>';
            document.rulemaker.xml_rulebase.value = '<rulebase xmlns:xg="blank">' + rulebase2.getLogicsheetXML() + '</rulebase>';
            document.rulemaker.xml_operations.value = document.getElementById('operations').value;
            document.rulemaker.xml_state.value = rulebase2.getStateXML();

            treeviewManager.ensureMaintainDocuments();

            showStatusMessage("Saving...", false);
            WinManager.setGenuineCloseFlag(false);
            document.rulemaker.submit();
        }


        function back()
        {
            if (rulebase2.hasChanges())
            {
                if (confirm("There are unsaved changes in this RuleBase which will be lost if you continue.\n\nAre you sure you wish to continue?") == false)
                {
                    return;
                }
            }

            ]]></xsl:text>
            <xsl:choose>
                <xsl:when test="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'caller'] = 'engine'">
                    //returning to engine viewer screen
                    document.rulemaker.action = "/xde/xde?action=Engine_Viewer.xsl";
                    document.rulemaker.controller.value="engine";
                    document.rulemaker.button_action.value="return_from_rulemaker";
                    document.rulemaker.main_action.value="";
                    document.rulemaker.submit();
                </xsl:when>
                <xsl:when test="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'caller'] = 'asset_list'">

                </xsl:when>
                <xsl:when test="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'caller'] = 'pattern_viewer'">
                    //returning to runtime pattern viewer screen
                    document.rulemaker.action = "/xde/xde?action=Pattern_Instance_Viewer.xsl";
                    document.rulemaker.controller.value="pattern_instance";
                    document.rulemaker.button_action.value="return_from_rulemaker_rules";
                    document.rulemaker.main_action.value="";
                    document.rulemaker.submit();
                </xsl:when>
            </xsl:choose>
            <xsl:text disable-output-escaping="yes"><![CDATA[
        }


        function viewProject()
        {
            if (rulebase2.hasChanges())
            {
                if (confirm("There are unsaved changes in this RuleBase which will be lost if you continue.\n\nAre you sure you wish to continue?") == false)
                {
                    return;
                }
            }

            document.rulemaker.action = "/xde/xde?action=Blueprint_Instance.xsl";
            document.rulemaker.controller.value="blueprint";
            document.rulemaker.button_action.value="view_instance";
            document.rulemaker.main_action.value="return_from_other_view";
            document.rulemaker.submit();
        }

        function viewAssets()
        {
            if (rulebase2.hasChanges())
            {
                if (confirm("There are unsaved changes in this RuleBase which will be lost if you continue.\n\nAre you sure you wish to continue?") == false)
                {
                    return;
                }
            }

            document.rulemaker.action = "/xde/xde?action=asset_types.xsl";
            document.rulemaker.controller.value="resource";
            document.rulemaker.button_action.value="show_asset_types";
            document.rulemaker.main_action.value="";
            document.rulemaker.submit();
        }

        function viewPatterns()
        {
            if (rulebase2.hasChanges())
            {
                if (confirm("There are unsaved changes in this RuleBase which will be lost if you continue.\n\nAre you sure you wish to continue?") == false)
                {
                    return;
                }
            }

            document.rulemaker.action = "/xde/xde?action=pattern_types.xsl";
            document.rulemaker.controller.value="pattern";
            document.rulemaker.button_action.value="show_pattern_types";
            document.rulemaker.main_action.value="";
            document.rulemaker.submit();
        }

        function viewPatternInstances()
        {
            if (rulebase2.hasChanges())
            {
                if (confirm("There are unsaved changes in this RuleBase which will be lost if you continue.\n\nAre you sure you wish to continue?") == false)
                {
                    return;
                }
            }

            document.rulemaker.action = "/xde/xde?action=pattern_instance_types.xsl";
            document.rulemaker.controller.value="pattern_instance";
            document.rulemaker.button_action.value="show_pattern_instance_types";
            document.rulemaker.main_action.value="";
            document.rulemaker.submit();
        }
        ]]></xsl:text>
        </script>
    </xsl:template>
    <!--
    top strip references to other screens
    -->
    <xsl:template name="top_menu">
        <div class="top_menu_primary">
            <div class="tab">
                <ul>
                    <li class="current"><a href="#">RuleMaker</a></li>
                    <xsl:if test="/xg:message/xg:header/xg:attributes/xform:instance/*" xmlns:xform="http://www.w3.org/2001/08/xforms">
                        <li><a href="javascript:viewProject()">Project</a></li>
                        <li><a href="javascript:viewAssets()">Assets</a></li>
                        <li><a href="javascript:viewPatterns()">Patterns</a></li>
                        <li><a href="javascript:viewPatternInstances()">Runtime Patterns</a></li>
                    </xsl:if>
                    <li><a id="documentation" name="documentation" href="/documentation/index.html" target="_blank">Help...</a></li>
                </ul>
            </div>
        </div>
    </xsl:template>
    <!--
    override left_menu
    -->
    <xsl:template name="left_menu">
    </xsl:template>
    <xsl:template name="section_title">
        RuleMaker
    </xsl:template>
    <xsl:template name="section_body">
        <div id="toolbar_container"/>
        <div id="context_information">
            <table border="0" cellpadding="0" cellspacing="0">
                <xsl:choose>
                    <xsl:when test="(/xg:message/xg:header/xg:attributes[not(xg:attribute[@xg:name = 'pattern_id']) or xg:attribute[@xg:name = 'pattern_id'] = '']) or (/xg:message/xg:header/xg:attributes[not(xg:attribute[@xg:name = 'pattern_id']) or xg:attribute[@xg:name = 'pattern_id'] = ''])">
                        <tr>
                            <td class="heading">Rulebase:</td>
                            <td>
                                <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'document']"/>
                            </td>
                        </tr>
                    </xsl:when>
                    <xsl:otherwise>
                        <!-- TODO: these are the ids of the pattern/node -  we should be showing the names!!!!!! -->
                        <tr>
                            <td class="heading">Runtime Pattern:</td>
                            <td>
                                <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'pattern_id']"/>
                            </td>
                        </tr>
                        <tr>
                            <td class="heading">Node:</td>
                            <td>
                                <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'node_id']"/>
                            </td>
                        </tr>
                    </xsl:otherwise>
                </xsl:choose>
            </table>
        </div>

        <div>
            <div style="float : left;">
                <a href="javascript:treeviewManager.toggleInputVisibility()">Toggle Input Document</a>
                <!--<xsl:text> | </xsl:text>-->
                <a href="javascript:treeviewManager.chooseInput()">Change</a>
            </div>
            <div style="float : right;">
                <a href="javascript:treeviewManager.toggleOutputVisibility()">Toggle Output Document</a>
                <!--<xsl:text> | </xsl:text>-->
                <a href="javascript:treeviewManager.chooseOutput()">Change</a>
            </div>
            <!--<xsl:text> | </xsl:text>-->
            <div style="margin-left : auto; margin-right : auto; width : 16em; text-align : center;">
                <xsl:if test="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'caller'] != ''">
                    <a href="javascript:back()">Back</a>
                </xsl:if>
                <a href="javascript:save()">Save</a>
                <xsl:if test="(/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'pattern_id'] != '') and (/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'pattern_id'] != '')">
                    <!--<xsl:text> | </xsl:text>-->
                    <a href="javascript:deployNode()">Deploy</a>
                </xsl:if>
            </div>
        </div>
        <table id="pageTable" border="0" cellspacing="0" cellpadding="0" style="visibility : hidden;">
            <tr>
                <td id="input_td" style="width : 15%; height : 100%">
                    <div class="TreeList" id="input_tree"></div>
                </td>
                <td id="divider_td" class="divider_td">
                    <div id="divider" class="divider" onmousedown="dividerPressed(document.getElementById('input_td'), 'left', event)" ondblclick="dividerDoubleClicked(document.getElementById('input_td'));">
                    </div>
                </td>
                <td id="main_content">
                    <div id="rulebase_container">
                </div>
                </td>
                <td id="divider2_td" class="divider_td">
                    <div id="divider2" class="divider" onmousedown="dividerPressed(document.getElementById('output_td'), 'right', event)" ondblclick="dividerDoubleClicked(document.getElementById('output_td'));">
                    </div>
                </td>
                <td id="output_td" style="width : 15%; height : 100%;">
                    <div class="TreeList" id="output_tree"></div>
                </td>
            </tr>
        </table>
        <!--<button onclick="document.getElementById('current_xml').value = rulebase2.getLogicsheetXML();">Show Current XML</button>
        <input type="text" id="current_xml" size="100"/>
        <button onclick="validate();">Validate</button><br/>
        <button onclick="document.getElementById('current_state_xml').value = rulebase2.getStateXML();">Show State XML</button>
        <input type="text" id="current_state_xml" size="100"/>
        <button onclick="document.getElementById('document_html').value = document.documentElement.innerHTML">Show HTML</button>
        <input type="text" id="document_html" size="100"/>-->
        <!--<xml id="treeviewStylesheet" src="xsl/InstanceTreeView.xsl"/>-->
        <!-- put rulebase in here -->
        <textarea style="display : none;" id="logicsheet_test" xmlns:xg="blank">
            <!--<xsl:copy-of select="/xg:message/xg:header/xg:attributes/xg:rulebase/rulebase/hyx:rulebase" xmlns:xg="http://www.hyfinity.com/xgate"/>-->
            <xsl:apply-templates select="/xg:message/xg:header/xg:attributes/xg:rulebase/rulebase/hyx:rulebase" mode="copy-to-textarea" xmlns:xg="http://www.hyfinity.com/xgate"/>
        </textarea>
        <!-- operations file goes here -->
        <textarea style="display : none;" id="operations">
            <xsl:copy-of select="/xg:message/xg:header/xg:attributes/xg:operations/hyx:rulemaker"/>
        </textarea>
        <textarea style="display : none;" id="rulebaseState">
            <xsl:copy-of select="/xg:message/xg:header/xg:attributes/xg:state/*"/>
        </textarea>
        <textarea style="display : none;" id="all_xstore_collections">
            <xstores filter="on" xmlns="http://www.hyfinity.com/xengine">
                <xstore name="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='xstore']}">
                    <collections>
                        <xsl:for-each select="/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@name = /xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project]/xf:resource_pool[not(starts-with(@type, 'fm_'))]">
                            <collection name="{@content}"/>
                        </xsl:for-each>
                        <!--<xsl:for-each select="/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@id = 'generic']/xf:resource_pool[not(starts-with(@type, 'fm_'))]">
                                    <collection name="{@content}"/>
                                </xsl:for-each>-->
                    </collections>
                </xstore>
            </xstores>
        </textarea>
        <textarea style="display : none;" id="xsl_xstore_collections">
            <xstores filter="on" xmlns="http://www.hyfinity.com/xengine">
                <xstore name="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='xstore']}">
                    <collections>
                        <xsl:for-each select="/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@name = /xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project]/xf:resource_pool[@type = 'XSL']">
                            <collection name="{@content}"/>
                        </xsl:for-each>
                        <!--<xsl:for-each select="/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@id = 'generic']/xf:resource_pool[@type = 'XSL']">
                                    <collection name="{@content}"/>
                                </xsl:for-each>-->
                    </collections>
                </xstore>
            </xstores>
        </textarea>
        <textarea style="display : none;" id="xsd_xstore_collections">
            <xstores filter="on" xmlns="http://www.hyfinity.com/xengine">
                <xstore name="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='xstore']}">
                    <collections>
                        <xsl:for-each select="/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@name = /xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project]/xf:resource_pool[@type = 'XSD']">
                            <collection name="{@content}"/>
                        </xsl:for-each>
                        <!--<xsl:for-each select="/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@id = 'generic']/xf:resource_pool[@type = 'XSD']">
                                    <collection name="{@content}"/>
                                </xsl:for-each>-->
                    </collections>
                </xstore>
            </xstores>
        </textarea>

        <textarea style="display : none;" id="input_document_content" xmlns:xg="blank">
            <!--<xsl:copy-of select="/xg:message/xg:header/xg:attributes/xg:input_document/*" xmlns:xg="http://www.hyfinity.com/xgate"/>-->
            <xsl:apply-templates select="/xg:message/xg:header/xg:attributes/xg:input_document/*" mode="copy-to-textarea" xmlns:xg="http://www.hyfinity.com/xgate"/>
        </textarea>
        <textarea style="display : none;" id="output_document_content" xmlns:xg="blank">
            <!--<xsl:copy-of select="/xg:message/xg:header/xg:attributes/xg:output_document/*" xmlns:xg="http://www.hyfinity.com/xgate"/>-->
            <xsl:apply-templates select="/xg:message/xg:header/xg:attributes/xg:output_document/*" mode="copy-to-textarea" xmlns:xg="http://www.hyfinity.com/xgate"/>
        </textarea>

        <input id="default_message_collection" value="{/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@name = /xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project]/xf:resource_pool[@type = 'Message'][1]/@content}" type="hidden"/>
        <input id="default_xsl_collection" value="{/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@name = /xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project]/xf:resource_pool[@type = 'XSL'][1]/@content}" type="hidden"/>
        <input id="default_xsd_collection" value="{/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@name = /xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project]/xf:resource_pool[@type = 'XSD'][1]/@content}" type="hidden"/>

        <!-- Stores the ID of the layer in which any proxy type nodes should be placed. (eg web service proxies, DB Connections, etc.) -->
        <input id="proxy_layer_id" type="hidden" value="{/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:layer[last()]/@layer_id}"/>
        <!-- QUESTION: How should we determine which pool to place any generated proxy patterns into??? -->
        <input id="proxy_collection" type="hidden" value="{/xg:message/xg:header/xg:attributes/xg:blueprint/xf:blueprint/xf:instance[@id = /xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project]/xf:pattern_instance_pool[last()]/@content}"/>

        <xform:xform xmlns:xform="http://www.w3.org/2001/08/xforms" xmlns:xfact="http://www.hyfinity.com/xfactory" xmlns:xg="http://www.hyfinity.com/xgate" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
            <xform:instance>
                <xsl:copy-of select="/xg:message/xg:header/xg:attributes/xform:instance/*"/>
            </xform:instance>
            <form id="rulemaker" name="rulemaker" method="post" action="../RuleMaker/RuleMaker">
                <textarea rows="7" cols="100" name="xml_project_details" style="display:none">
                    <xsl:copy-of select="/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details"/>
                </textarea>
                <input type="hidden" name="collection" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'collection']}"/>
                <input type="hidden" name="document" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'document']}"/>
                <input type="hidden" name="xstore" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'xstore']}"/>
                <input type="hidden" name="node_id" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'node_id']}"/>
                <input type="hidden" name="pattern_id" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'pattern_id']}"/>
                <input type="hidden" name="xml_rulebase" value=""/>
                <input type="hidden" name="xml_operations" value=""/>
                <input type="hidden" name="xml_blueprint" value=""/>
                <input type="hidden" name="server_action" value="save"/>
                <input type="hidden" name="xml_processing" value=""/>
                <input type="hidden" name="xml_state" value=""/>
                <input name="deploy_requested" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'deploy_requested']}" type="hidden"/>
                <input name="caller" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'caller']}" type="hidden"/>

                <!-- fields needed to maintain display of temporary instance documents, eg from log viewer -->
                <input type="hidden" name="xml_input_document" value=""/>
                <input type="hidden" name="xml_output_document" value=""/>

                <!-- extra fields needed to return to XDE -->
                <input type="hidden" name="controller" value=""/>
                <input type="hidden" name="main_action" value=""/>
                <input type="hidden" name="button_action" value=""/>
            </form>
        </xform:xform>
        <xform:xform xmlns:xform="http://www.w3.org/2001/08/xforms" xmlns:xfact="http://www.hyfinity.com/xfactory" xmlns:xg="http://www.hyfinity.com/xgate" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
            <xform:instance>
                <xsl:copy-of select="/xg:message/xg:header/xg:attributes/xform:instance/*"/>
            </xform:instance>
            <form id="rulemakerTarget" name="rulemakerTarget" method="post" action="../RuleMaker/RuleMaker">
                <textarea rows="7" cols="100" name="xml_project_details" style="display:none">
                    <xsl:copy-of select="/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details"/>
                </textarea>
                <input type="hidden" name="xstore" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'xstore']}"/>
                <input type="hidden" name="node_id" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'node_id']}"/>
                <input type="hidden" name="pattern_id" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'pattern_id']}"/>
            </form>
        </xform:xform>
        <form target="serviceCallHelperWindow" name="serviceCallHelperCaller" method="post" action="serviceCallHelper">
            <input type="hidden" name="username" value="{/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:user}"/>
            <input type="hidden" name="blueprint_name" value="{/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:product}"/>
            <input type="hidden" name="blueprint_location" value="{/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:blueprint_location}"/>
            <input type="hidden" name="blueprint" value="{/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project}"/>
            <input type="hidden" name="project_name" value="{/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project_name}"/>
            <input type="hidden" name="layer_filter" value=""/>
            <input type="hidden" name="new_pattern_collection"/>
            <input type="hidden" name="display_mode" value="normal"/>
        </form>
        <form target="xstoreViewerWindow" name="xstoreViewerCaller" method="post" action="../xstoreViewer/xstoreviewer">
            <textarea name="xml_permissions" rows="1" cols="1" style="display:none">
                <xstores filter="off" xmlns="http://www.hyfinity.com/xengine">
                    <xstore name="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='xstore']}"/>
                </xstores>
            </textarea>
            <input name="action" value="call" type="hidden"/>
            <input name="chosen_xstore_name" value="{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='xstore']}" type="hidden"/>
            <input name="chosen_collection_name" value="" type="hidden"/>
            <input name="chosen_document_name" value="" type="hidden"/>
            <input name="selection_mode" value="id" type="hidden"/>
        </form>
        <script type="text/javascript">

                    if (document.rulemaker.deploy_requested.value == 'true')
                    {
                        initiateDeploy();
                        document.rulemaker.deploy_requested.value = 'false';
                    }

                </script>

    </xsl:template>
    <xsl:template name="tagline">
        <!--<div id="tagline" xmlns:xg="http://www.hyfinity.com/xgate">-->
            <a href="javascript:logout();" id="logout" class="logout_btn">Change Workspace</a>
            <xsl:variable name="projectName">
                <xsl:choose>
                    <xsl:when test="/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project_name">
                        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project_name"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:project"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <span id="heading">Project: <xsl:value-of select="$projectName"/>
            </span>
            <img src="images/{/xg:message/xg:header/xg:attributes/xg:project_details/xf:project_details/xf:product}.png" alt=""/>
        <!--</div>-->
    </xsl:template>
</xsl:stylesheet>
