<?xml version="1.0" encoding="UTF-8"?>
<out:stylesheet xmlns:out="http://www.w3.org/1999/XSL/Transform" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:sxf="http://www.w3.org/2001/08/xforms" version="1.0">

    <out:import href="xde_skin_html.xsl"/>

    <out:output method="xml" indent="yes"/>

    <xsl:template name="client-scripts">

        <script language="javascript">
            <xsl:text disable-output-escaping="yes"><![CDATA[
        function new_instance(x) {
            if (checkName())
            {
                //alert("action triggered with param "+x+". Need to insert some logic here");
                document.blueprint_instances_xform.action.value = 'Blueprint_Instances.xsl';
                document.blueprint_instances_xform.button_action.value="new_instance";
                document.blueprint_instances_xform.main_action.value="new_instance";
                document.blueprint_instances_xform.controller.value = 'blueprint_manipulation';
                document.blueprint_instances_xform.submit();
                showStatusMessage('Please wait while the new project is created...');
                disableForm();
            }
        }

        function copy_instance(x) {
            if (checkName() && checkSelect())
            {
                //alert("action triggered with param "+x+". Need to insert some logic here");
                document.blueprint_instances_xform.action.value = 'Blueprint_Instances.xsl';
                document.blueprint_instances_xform.button_action.value="copy_instance";
                document.blueprint_instances_xform.main_action.value="copy_instance";
                document.blueprint_instances_xform.controller.value = 'blueprint_manipulation';
                document.blueprint_instances_xform.submit();
                showStatusMessage('Please wait while the project is being copied...');
                disableForm();
            }
        }

        function delete_instance(x) {
            if (checkSelect())
            {
                if (confirm('This operation will permanently delete the selected project, and cannot be undone.\n\nAre you sure you wish to continue?'))
                {
                    document.blueprint_instances_xform.action.value = 'Blueprint_Instances.xsl';
                    document.blueprint_instances_xform.button_action.value="delete_instance";
                    document.blueprint_instances_xform.main_action.value="delete_instance";
                    document.blueprint_instances_xform.controller.value = 'blueprint_manipulation';
                    document.blueprint_instances_xform.submit();
                    showStatusMessage('Please wait while the project is deleted...');
                    disableForm();
                }
            }
        }

        function import_instance(x) {
            //if (checkName())
            //{
                //alert("action triggered with param "+x+". Need to insert some logic here");
                document.blueprint_instances_xform.action.value = 'Import_Instance.xsl';
                document.blueprint_instances_xform.button_action.value="import_instance_details";
                document.blueprint_instances_xform.main_action.value="import_instance_details";
                document.blueprint_instances_xform.controller.value = '';
                document.blueprint_instances_xform.submit();
                disableForm();
            //}
        }

        function export_instance() {
            var selected = checkSelect();
            if (selected != false)
            {
                document.blueprint_instances_xform.requested_blueprint_instance.value = selected;
                //TODO: should actually use the name, rather than the id for the project name value.
                document.blueprint_instances_xform.project_name.value = selected;
                document.blueprint_instances_xform.action.value = 'Export_Instance.xsl';
                document.blueprint_instances_xform.button_action.value="export_instance";
                document.blueprint_instances_xform.main_action.value="export_instance";
                document.blueprint_instances_xform.controller.value = 'export_instance';
                document.blueprint_instances_xform.submit();
                showStatusMessage('Creating project export. Please wait for the save dialog to appear...', true);

            }
        }

        function instance(id, name) {
            //alert("action triggered with param "+x+". Need to insert some logic here");
            //alert('id=' + id + ' name=' + name);
            document.blueprint_instances_xform.requested_blueprint_instance.value = id;
            document.blueprint_instances_xform.project_name.value = name;
            document.blueprint_instances_xform.action.value = 'Blueprint_Instance.xsl';
            document.blueprint_instances_xform.button_action.value="view_instance";
            document.blueprint_instances_xform.main_action.value="view_instance";
            document.blueprint_instances_xform.controller.value = 'blueprint';
            document.blueprint_instances_xform.submit();
            disableForm();
        }

        function checkName()
        {
            // regular expression \W matches all non-alphanumeric characters.  it allows the '_' character but will reject spaces
            var filter = /[\W]/;
            if(filter.test(document.blueprint_instances_xform.new_name.value))
            {
                alert("Invalid name. Please do not include non-alphanumeric values or spaces.");
                return false;
            }
            else if(document.blueprint_instances_xform.new_name.value == "")
            {
                alert("Please enter a name before submitting");
                return false;
            }
            return true;
        }
        function checkSelect()
        {
            var selected = false;
            if (document.blueprint_instances_xform.blueprint_instance_select.length == undefined)
            {
                if (document.blueprint_instances_xform.blueprint_instance_select.checked == true)
                {
                    selected = document.blueprint_instances_xform.blueprint_instance_select.value;
                }
            }
            else
            {
                for (var i=0; i < document.blueprint_instances_xform.blueprint_instance_select.length; ++i)
                {
                    if (document.blueprint_instances_xform.blueprint_instance_select[i].checked == true)
                    {
                        selected = document.blueprint_instances_xform.blueprint_instance_select[i].value;
                    }
                }
            }
            if (!selected)
            {
                alert('Please select an existing project before submitting');
            }
            return selected;
        }

        function back()
        {
            document.blueprint_instances_xform.action.value = 'list_blueprint_types.xsl';
            document.blueprint_instances_xform.controller.value = 'list_projects';
            document.blueprint_instances_xform.button_action.value="check_blueprints";
            document.blueprint_instances_xform.main_action.value="show_blueprint_types";
            document.blueprint_instances_xform.submit();
            disableForm();
        }

        /* Shows the FormMaker application map screen for the selected project */
        function viewProjectInFM(id, name, user, product, blLocation)
        {
            document.formmakerForm.xml_project_info.value =
                '<project_details xmlns="http://www.hyfinity.com/xfactory">'
                    + '<user>' + user + '</user>'
                    + '<product>' + product + '</product>'
                    + '<blueprint_location>' + blLocation + '</blueprint_location>'
                    + '<project>' + id + '</project>'
                    + '<project_name>' + name + '</project_name>'
                + '</project_details>';

            document.formmakerForm.submit();
        }

var hideStatusTimeout;

function showStatusMessage(message, autohide)
{
    if (hideStatusTimeout != null)
    {
        clearTimeout(hideStatusTimeout);
        hideStatusTimeout = null;
    }

    var messageContainer = document.getElementById("status_message");
    if (messageContainer == null)
    {
        messageContainer = document.createElement('div');
        messageContainer.setAttribute('id', 'status_message');
        messageContainer.className = 'gen_response';
        document.body.insertBefore(messageContainer, document.getElementById('temp_divider'));
    }

    messageContainer.style.display = 'block';
    messageContainer.innerHTML = message;


    if (autohide == true)
    {
        hideStatusTimeout = setTimeout(hideStatusMessage, 15000);
    }

}


/**
 * hides the status Message
 */
function hideStatusMessage()
{
    var messageContainer = document.getElementById("status_message");
    if (messageContainer != null)
    {
        messageContainer.style.display = 'none';
        messageContainer.innerHTML = "";
        hideStatusTimeout = null;
    }
}

        ]]></xsl:text>
        </script>

    </xsl:template>
    <xsl:template name="top-menu">
        <div class="tab">
            <ul>
                <li><a href="javascript:back()">Application Types</a></li>
                <li class="current"><a href="#">Projects</a></li>
                <li><a id="documentation" name="documentation" href="/documentation/index.html" target="_blank">Help...</a></li>
            </ul>
        </div>
    </xsl:template>

    <xsl:template name="section-body">
        <xform:xform xmlns:xform="http://www.w3.org/2001/08/xforms" xmlns:xfact="http://www.hyfinity.com/xfactory" xmlns:xg="http://www.hyfinity.com/xgate" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
            <xform:instance>
                <xsl:copy-of select="/"/>
            </xform:instance>
            <form id="blueprint_instances_xform" name="blueprint_instances_xform" action="xde" method="post">
                <input type="hidden" name="action" value="xde_test"/>
                <div class="heading">Available Projects</div>
                <div id="caption">Name of New Project</div>
                <span id="input">
                    <input type="text" id="new_name" name="new_name" value="{/xg:message/xg:body/xfact:blueprint/xfact:result/xfact:newName}" size="30" onkeypress="return blockEnter();"/>
                    <input type="hidden" id="new_name_xpath" name="new_name_xpath" value=""/>
                </span>
                <span id="button">
                    <a id="new_instance" name="new_instance" href="javascript:new_instance()">New</a>
                </span>
                <span id="button">
                    <a id="copy_instance" name="copy_instance" href="javascript:copy_instance()">Copy</a>
                </span>
                <span id="button">
                    <a id="delete_instance" name="delete_instance" href="javascript:delete_instance()">Delete</a>
                </span>
                <span id="button">
                    <a id="export_instance" name="export_instance" href="javascript:export_instance()">Export</a>
                </span>
                <span id="button">
                    <a id="import_instance" name="import_instance" href="javascript:import_instance()">Import</a>
                </span>
                <div id="caption">Projects</div>
                <div id="repeat" name="repeat">
                    <div id="group">
                        <span id="selectBooleanHeading">
                        </span>
                        <span id="buttonHeading">Name</span>
                        <span class="outputHeading">Description</span>
                    </div>
                    <xsl:for-each select="/xg:message/xg:body/xfact:user/xfact:blueprint[@name = /xg:message/xg:header/xg:attributes/xg:attribute[@xg:name = 'blueprint_name']]/xfact:instance">
                        <xsl:sort select="@name"/>
                        <xsl:variable name="BIname" select="@name"/>
                        <xsl:for-each select="/xg:message/xg:body/xfact:blueprint/xfact:instance[@id = $BIname]">
                            <div id="group" name="group">
                                <span id="selectBoolean">
                                    <input type="radio" id="blueprint_instance_select" name="blueprint_instance_select" value="{@id}"/>
                                </span>
                                <span id="button">
                                    <a id="instance" name="instance" href="javascript:instance('{@id}', '{@name}')">
                                        <xsl:value-of select="@name"/>
                                    </a>
                                </span>
                                <span class="outputLarge" id="instance_desc" name="instance_desc" ref="@desc">
                                    <xsl:value-of select="@desc"/>
                                </span>
                                <!--<xsl:if test="/xg:message/xg:body/xfact:blueprint/xfact:plugins/xfact:plugin[@type = 'FormMaker']" >
                                    <span id="button">
                                        <a href="javascript:viewProjectInFM('{@id}', '{@name}', '{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='username']}', '{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='blueprint_name']}', '{/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='blueprint_location']}')">View in FormMaker</a>
                                    </span>
                                </xsl:if>-->
                            </div>
                        </xsl:for-each>
                    </xsl:for-each>
                </div>
                <input type="hidden" name="requested_blueprint_instance" value=""/>
                <input type="hidden" name="project_name" value=""/>
                <input type="hidden" name="controller" value="blueprint"/>
                <input type="hidden" name="button_action" value=""/>
                <input type="hidden" name="main_action" value=""/>
                <input type="hidden" name="new_collection_path" value=""/>
                <input type="hidden" name="export_path" value=""/>
            </form>
            <span id="button">
                <a id="back" name="back" href="javascript:back()">Back</a>
            </span>
        </xform:xform>

        <xsl:if test="/xg:message/xg:body/xfact:blueprint/xfact:plugins/xfact:plugin[@type = 'FormMaker']" xmlns:xg="http://www.hyfinity.com/xgate" xmlns:xfact="http://www.hyfinity.com/xfactory">
            <form name="formmakerForm" action="../formmaker/FormMaker" method="post">
                <input type="hidden" name="action" value="process"/>
                <input type="hidden" name="operation1" value="load_form_map"/>
                <input type="hidden" name="presentation_xsl" value="form_map_html.xsl"/>
                <!-- Is it ok to just hard code the name of the application file??? -->
                <input type="hidden" name="form_map_filename" value="application.xml"/>
                <input type="hidden" name="xml_project_info" value=""/>
            </form>
        </xsl:if>
    </xsl:template>

    <xsl:template name="tagline" xmlns:xg="http://www.hyfinity.com/xgate">
        <a href="javascript:logout();" id="logout" class="logout_btn">Change Workspace</a>
    </xsl:template>

    <xsl:template name="section-name">
        <xsl:text>Projects</xsl:text>
    </xsl:template>

</out:stylesheet>
