//DOM document variables
var DOMDoc, pictureDoc, controlsDoc;
var imagesDoc, blueprintDoc;
//picture groups to contain all graphical components
var nodes, links;
//used to store the current graphical element that is being manipulated
var object = null;
var startTarget = null;
//coordinate variables for movement etc.
var currentX = 0;
var currentY = 0;
var originX = 0;
var originY = 0;
//stores the current mode - movenode, addnode, deletenode, addcons, deletecons or editcons
var mode = '';
//used to store connection details when processing XML
var cons_start, cons_end;
//stores the position at which to draw each node if it doesnt have xpos, ypos attributes
var defaultx = 40, defaulty = 40;
//stores the location of the picture to use for each node
//should be passed in somehow
var defaultPicture = '';
//sets the size of the pictures
var picHeight = 40;
var picWidth = 40;

var added = false;

var PIMode="logicsheet"
var viewingPI = false;

var patternID;


//namespace variables;
var defaultNS = 'http://www.hyfinity.com/xfactory';
var qualifiedNS = 'xmlns:xfact="http://www.hyfinity.com/xfactory"';

var SVG_NS ="http://www.w3.org/2000/svg";
var XLINK_NS ="http://www.w3.org/1999/xlink";


function init()
{
    //alert(document.getElementById('pattern_viewer'));
    //alert(document.getElementById('pattern_viewer').getSVGDocument)
    //alert(document.getElementById('pattern_viewer').getSVGDocument())
    pictureDoc = document.getElementById('pattern_viewer').getSVGDocument();
    if (document.getElementById('controls') == null)
    {
        controlsDoc = null;
        loadBlueprintXML();
        viewingPI = true;
    }
    else
    {
        controlsDoc = document.getElementById('controls').getSVGDocument();
        viewingPI = false;
    }
    //alert(controlsDoc);
    nodes = pictureDoc.getElementById('nodes');
    links = pictureDoc.getElementById('links');
    defaultPicture = document.pattern_viewer_xform.node_image.value;

    readXML();
    //if (controlsDoc != null)
        setMode('movenode');

    setPIMode('logicsheet');
//	document.pattern_viewer_xform.PIMode[0].checked = true;
}

function loadBlueprintXML()
{
    //load up the blueprint xml DOM
    blueprintDoc = getXMLIsland('blueprint');
    Sarissa.setXpathNamespaces(blueprintDoc, qualifiedNS);

}

function readXML()
{

    imagesDoc = getXMLIsland('node_images');
    Sarissa.setXpathNamespaces(imagesDoc, qualifiedNS);


    DOMDoc = getXMLIsland('pattern');
    Sarissa.setXpathNamespaces(DOMDoc, qualifiedNS);

    patternID=DOMDoc.selectSingleNode("/xfact:pattern").getAttribute("pattern_id");
    //alert(patternID);

    processXML();
    document.pattern_viewer_xform.xml_data.value = new XMLSerializer().serializeToString(DOMDoc);;
}

function processXML()
{
    cons_start = new Array();
    cons_end = new Array();
    var nodes = DOMDoc.selectSingleNode('/xfact:pattern/xfact:nodes');
    for (var x = 0; x<nodes.childNodes.length; ++x)
    {
        if (getBaseName(nodes.childNodes.item(x)) == ('node'))
        {
            processNode(nodes.childNodes.item(x));
        }
    }
    processCons();
}

function processNode(elem)
{
    var xpos = elem.getAttribute('xpos');
    var ypos = elem.getAttribute('ypos');
    if (ypos == null)
        ypos = defaulty;
    if (xpos == null)
    {
        xpos = defaultx;
        defaultx += 60;
        if (Number(Number(defaultx) + Number(30)) > Number(this.document.pattern_viewer.getAttribute('width')))
        {
            defaultx = 40;
            defaulty += 60;
        }
    }
    var id = elem.getAttribute('node_id');
    var name = elem.getAttribute('name');
    var picAtt = elem.getAttribute('image');
    //alert(picAtt);
    var picture = defaultPicture;
    if ((picAtt != null) && (picAtt != ''))
    {
        picture = imagesDoc.selectSingleNode('/xfact:node_images/xfact:image[@id="'+picAtt+'"]').getAttribute('name');
        //alert(picture);
    }

    //create the new node
    if (!viewingPI)
        newNode(xpos, ypos, id, name, picture);
    else
    {
        var blNodeTag = blueprintDoc.selectSingleNode('/xfact:blueprint/xfact:instance[@id="'+rbi+'"]/xfact:pattern_instance[@pattern_instance_ref="'+patternID+'"]/xfact:node[@id="'+id+'"]');
        //alert(blNodeTag);
        if (blNodeTag == null)
            newNode(xpos, ypos, id, name, picture);
        else
        {
            var imageEntry = imagesDoc.selectSingleNode('/xfact:node_images/xfact:image[@id="'+blNodeTag.getAttribute("image")+'"]');
            if (imageEntry == null)
                newNode(xpos, ypos, id, name, picture);
            else
                newNode(xpos, ypos, id, name, imageEntry.getAttribute('name'));
        }
    }

    //find partner nodes
    var partners = elem.selectNodes('./xfact:partner_nodes/xfact:partner_node');
    //alert(partners.length);
    for (var i=0; i<partners.length; ++i)
    {
        //alert(partners.item(i).getAttribute('node_ref'));
        cons_start[cons_start.length] = id;
        cons_end[cons_end.length] = partners.item(i).getAttribute('node_ref');
    }
}

//draw all node connections
function processCons()
{
    //alert(cons_start.length);
    for (var i=0; i<cons_start.length; ++i)
    {
        var start = pictureDoc.getElementById(cons_start[i]).firstChild;
        var end = pictureDoc.getElementById(cons_end[i]).firstChild;
        var startCoords = getCentreCoords(start);
        var endCoords = getCentreCoords(end);

        //check if there is a link in both directions between the two nodes
        var other = -1;
        for (var x=0; x<cons_start.length; ++x)
        {
            if ((cons_start[i] == cons_end[x]) && (cons_start[x] == cons_end[i]))
            {
                //alert("Bidirectional link");
                other = x;
            }

        }

        if (other != -1)
        {
            if (other > i)
            {
                startCoords[1] = Number(startCoords[1]) + Number(7);
                endCoords[1] = Number(endCoords[1]) + Number(7);
            }
            else
            {
                startCoords[1] = Number(startCoords[1]) - Number(7);
                endCoords[1] = Number(endCoords[1]) - Number(7);
            }

        }

        /*var x1 = start.getAttribute('cx');
        var y1 = start.getAttribute('cy');
        var x2 = end.getAttribute('cx');
        var y2 = end.getAttribute('cy');*/
        //alert(x1+' '+y1+' '+x2+' '+y2+' '+cons_start[i]+' '+cons_end[i]);
        newLine(startCoords[0],startCoords[1],endCoords[0],endCoords[1],cons_start[i], cons_end[i]);
    }
}


function newNode(x, y, id, name, imagePath)
{
    //alert('creating new node:' + x +', ' + y + ', ' + id + ', ' + name + ', ' + imagePath);

    //var circle = pictureDoc.createElement('circle');
    /*var circle = pictureDoc.createElementNS(SVG_NS, 'circle');
    circle.setAttribute('r', 20);
    circle.setAttribute('cx', x);
    circle.setAttribute('cy', y);
    circle.setAttribute('id', 'circle');
    circle.setAttribute('style', 'fill:white;stroke:black;stroke-width:2;');*/
    var dummy = pictureDoc.getElementById('dummy_image');
    var image = dummy.cloneNode(true);
    image.setAttribute('id', 'element');
    image.setAttribute('x', x-(picWidth/2));
    image.setAttribute('y', y-(picHeight/2));
    image.setAttribute('width', picWidth);
    image.setAttribute('height', picHeight);
    image.setAttribute('display', 'inline');

    //alert("using image: "+imagePath);

    if (imagePath == null || imagePath == '')
    {
        imagePath = defaultPicture;
        //alert("using new image path : "+imagePath);
    }

    //image.setAttribute('xlink:href', imagePath);
    image.setAttributeNS(XLINK_NS, 'xlink:href', imagePath)
    var text = pictureDoc.createElementNS(SVG_NS, 'text');
    var textData = pictureDoc.createTextNode(name);
    text.appendChild(textData);
    /*var textWidth = name.length*6;
    text.setAttribute('x', Number(x) - Number(textWidth/2));*/
    text.setAttribute('x', x);
    text.setAttribute('text-anchor', 'middle');
    text.setAttribute('y', Number(y) + Number(30));
    var group = pictureDoc.createElementNS(SVG_NS, 'g');
    group.setAttribute('onmousedown', 'parent.mouseDown(evt);');
    //group.onmousedown = mouseDown;
    group.setAttribute('onclick', 'parent.showNodeDetails(evt)');
    group.setAttribute('id', id);
    //group.appendChild(circle);
    group.appendChild(image);
    group.appendChild(text);
    /*var a = pictureDoc.createElement('a');
    a.setAttribute('pointer-events', 'none');
    a.appendChild(group);*/
    nodes.appendChild(group);

}

function newLine(x1, y1, x2, y2, startId, endId)
{
    var elem = pictureDoc.createElementNS(SVG_NS, 'line');
    elem.setAttribute('x1', x1);
    elem.setAttribute('x2', x2);
    elem.setAttribute('y1', y1);
    elem.setAttribute('y2', y2);
    elem.setAttribute('stroke-width', 1);
    elem.setAttribute('style', 'fill:none;stroke:gray');
    elem.setAttribute('marker-end', 'url(#Triangle)');
    elem.setAttribute('id', startId+'*@*@*'+endId);
    elem.setAttribute('onclick', 'parent.lineClick(evt);');
    //elem.setAttribute('pointer-events', 'none');
    var a = pictureDoc.createElementNS(SVG_NS, 'a');
    a.appendChild(elem);
    links.appendChild(a);
    return a;
}

function newHighlight(x1, y1, x2, y2, startId, endId)
{
    var elem = pictureDoc.createElementNS(SVG_NS, 'line');
    elem.setAttribute('x1', x1);
    elem.setAttribute('x2', x2);
    elem.setAttribute('y1', y1);
    elem.setAttribute('y2', y2);
    elem.setAttribute('stroke-width', 20);
    elem.setAttribute('opacity', 0.4);
    elem.setAttribute('fill', 'none');
    elem.setAttribute('stroke', 'yellow');
    elem.setAttribute('id', startId+endId);
    links.appendChild(elem);
    return elem;
}

function setMode(newMode, mouseEvent)
{
    if (mode != '')
    {
        var text = controlsDoc.getElementById(mode);
        text.setAttribute('fill', 'black');
    }
    mode = newMode;
    if (controlsDoc != null)
    {
        var text = controlsDoc.getElementById(mode);
        text.setAttribute('fill', 'blue');
    }
    if (typeof(mouseEvent) != 'undefined')
        mouseEvent.preventDefault();
    return false;
}

function doReset(mouseEvent)
{
    links.parentNode.removeChild(links);
    nodes.parentNode.removeChild(nodes);
    nodes = pictureDoc.createElementNS(SVG_NS, 'g');
    links = pictureDoc.createElementNS(SVG_NS, 'g');
    var components = pictureDoc.getElementById('components');
    components.appendChild(links);
    components.appendChild(nodes);
    readXML();
    mouseEvent.preventDefault();
    return false;
}

function mouseDown(mouseEvent)
{
    added = false;
    //alert(mouseEvent.target.nodeName);
    startTarget = mouseEvent.target;
    switch (mode)
    {
    case 'movenode' :
        object = mouseEvent.target.parentNode;/*.parentNode;//the 'a' tag*/
        originX = mouseEvent.clientX;
        originY = mouseEvent.clientY;
        currentX = originX;
        currentY = originY;
        break;
    case 'addcons':
        object = mouseEvent.target;
        var coords = getCentreCoords(object);
        var start = object.parentNode.getAttribute('id');
        object = newLine(coords[0],coords[1],coords[0],coords[1],start,'');
        object.firstChild.setAttribute('marker-end', 'url(#Triangle2)');
        break;
    /*case 'deletecons':
    case 'editcons':
        object = mouseEvent.target;
        var coords = getCentreCoords(object);
        var start = object.parentNode.getAttribute('id');
        object = newHighlight(coords[0],coords[1],coords[0],coords[1],start,'');
        break;*/
    case 'deletenode':
        object = mouseEvent.target.parentNode;
        break;
    default	:	break;
    }

    //alert(object.getAttribute('id')+" *** "+object.nodeName);
    mouseEvent.preventDefault();
    return false;
}

function mouseUp(mouseEvent)
{
    //alert('mouseUp');
    if (object != null)
    {
        switch (mode)
        {
            case 'movenode'	:
                //alert('test');
                saveTransform(object);
                updateDOMCoords(object);
                break;
            case 'addcons'	:
                var target = mouseEvent.target;
                if (startTarget == target)
                    break;
                //the main visible component for a node has id 'element'
                if (target.getAttribute('id') == 'element')
                {
                    var coords = getCentreCoords(target);
                    object.firstChild.setAttribute('x2', coords[0]);
                    object.firstChild.setAttribute('y2', coords[1]);
                    var end = target.parentNode.getAttribute('id');
                    addCon(end)
                }
                else
                    links.removeChild(object);
                break;
            /*case 'deletecons'	:
                var target = mouseEvent.target;
                if (startTarget == target)
                    break;
                //the main visible component for a node has id 'element'
                if (target.getAttribute('id') == 'element')
                {
                    var end = target.parentNode.getAttribute('id');
                    var start = object.getAttribute('id');
                    links.removeChild(object);
                    //alert(start);
                    removeCon(start, end);
                }
                else
                    links.removeChild(object);
                break;
            case 'editcons'		:
                var target = mouseEvent.target;
                if (startTarget == target)
                {
                    links.removeChild(object);
                    break;
                }
                //the main visible component for a node has id 'element'
                if (target.getAttribute('id') == 'element')
                {
                    var end = target.parentNode.getAttribute('id');
                    editCon(end);
                }
                else
                    links.removeChild(object);
                break;*/
            case 'deletenode'	:
                var node = mouseEvent.target.parentNode;
                if (object.getAttribute('id') == node.getAttribute('id'))
                {
                    var start = object.getAttribute('id');
                    removeCons(start);
                    removeNodeFromDOM(object.getAttribute('id'));
                    nodes.removeChild(object);
                }
            default	:	break;
        }
    object = null;
    }
    if (mode == 'addnode')
    {
        if (mouseEvent.target.getAttribute('id') != 'background')
        {
            return;
        }
        var X = mouseEvent.clientX;
        var Y = mouseEvent.clientY;
        var id = prompt("Enter the node_id:", "enter node_id here");
        //alert(id);
        if (id!=null)
        {
            var node = DOMDoc.selectSingleNode("/xfact:pattern/xfact:nodes/xfact:node[@node_id = '"+id+"']");
            if (node != null)
            {
                alert('There is already a node in this pattern with that id!');
            }
            else
            {
                added = true;
                newNode(X, Y, id, id);
                addNodeToDOM(X, Y, id);
            }
        }
    }
}

function mouseMove(mouseEvent)
{
    if (object != null)
    {
        switch (mode)
        {
            case 'movenode'	:
                var X = mouseEvent.clientX;
                var Y = mouseEvent.clientY
                var xdiff = X - originX;
                var ydiff = Y - originY;
                var transform = "translate("+xdiff+" "+ydiff+")";
                object./*firstChild.*/setAttribute('transform', transform);
                checkCons(object, X-currentX, Y-currentY);
                currentX = X;
                currentY = Y;
                break;
            case 'addcons'	:
            /*case 'deletecons':
            case 'editcons'	:*/
                var X = mouseEvent.clientX;
                var Y = mouseEvent.clientY
                object.firstChild.setAttribute('x2', X);
                object.firstChild.setAttribute('y2', Y);
                break;
            default	:	break;
        }
    }
}

function lineClick(mouseEvent)
{
    var lineID = mouseEvent.target.getAttribute('id');
    //alert(lineID);
    var Ids = lineID.split('*@*@*');
    if (mode == 'deletecons')
    {
        removeCon(Ids[0], Ids[1]);
    }
    else if (mode == 'editcons')
    {
        editCon(Ids[0], Ids[1]);
    }

    mouseEvent.preventDefault();
    return false;
}

function getCentreCoords(elem)
{
    var coords = new Array(2);
    switch (elem.nodeName)
    {
        case 'ellipse':
        case 'circle':	coords[0] = elem.getAttribute('cx');
                        coords[1] = elem.getAttribute('cy');
                        break;
        case 'image':
        case 'rect':	var width = elem.getAttribute('width');
                        var height = elem.getAttribute('height');
                        coords[0] = Number(elem.getAttribute('x')) + Number((width/2));
                        coords[1] = Number(elem.getAttribute('y')) + Number((height/2));
                        break;
        case 'a'	:	coords = getCentreCoords(elem.firstChild);
        default:		alert('Node name not known!!');
                        break;
    }
    return coords;

}

function saveTransform(obj)
{
    var transform = obj/*.firstChild*/.getAttribute('transform');
    if ((transform != null) && (transform.search('translate') != -1))
    {
        var start = transform.indexOf('(');
        var mid = transform.indexOf(' ');
        var end = transform.indexOf(')');
        var transx = parseInt(transform.substring(start+1, mid));
        var transy = transform.substring(mid+1, end);

        translateObject(obj, transx, transy);
        obj.setAttribute('transform', '');
        obj.removeAttribute('transform');
        //checkCons(object, transx, transy);
    }

}

function translateObject(obj, transx, transy)
{
    var type = obj.nodeName;
    switch (type)
    {
        case 'ellipse':
        case 'circle' : obj.setAttribute('cx', Number(obj.getAttribute('cx')) + Number(transx));
                        obj.setAttribute('cy', Number(obj.getAttribute('cy')) + Number(transy));
                        break;
        case 'line'	: 	obj.setAttribute('x1', Number(obj.getAttribute('x1')) + Number(transx));
                        obj.setAttribute('y1', Number(obj.getAttribute('y1')) + Number(transy));
                        obj.setAttribute('x2', Number(obj.getAttribute('x2')) + Number(transx));
                        obj.setAttribute('y2', Number(obj.getAttribute('y2')) + Number(transy));
                        break;
        case 'rect'	:
        case 'text'	:
        case 'image':	obj.setAttribute('x', Number(obj.getAttribute('x')) + Number(transx));
                        obj.setAttribute('y', Number(obj.getAttribute('y')) + Number(transy));
                        break;
        case 'a'	:
        case 'g'	: 	for (var j=0; j<obj.childNodes.length; ++j)
                        {
                            var childobj = obj.childNodes.item(j);
                            translateObject(childobj, transx, transy);
                        }
                        break;
        default		: 	break;

        //still need to implement path, ellipse,....
    }
}

//check any connections for node (obj) and update coords if needed
function checkCons(obj, x, y)
{
    var list = pictureDoc.getElementsByTagName('line');
    //alert(list.length);
    var nodeid = obj/*.firstChild*/.getAttribute('id');
    //alert(nodeid);
    for (var z=0; z<list.length; ++z)
    {
        var line = list.item(z);
        var splitID = line.getAttribute('id').split('*@*@*');
        //alert(splitID[0]);
        //alert(splitID[1]);
        if (splitID[0] == nodeid)
        {
            //alert('first');
            line.setAttribute('x1', Number(line.getAttribute('x1')) + Number(x));
            line.setAttribute('y1', Number(line.getAttribute('y1')) + Number(y));
        }
        else if (splitID[1] == nodeid)
        {
            //alert('second');
            line.setAttribute('x2', Number(line.getAttribute('x2')) + Number(x));
            line.setAttribute('y2', Number(line.getAttribute('y2')) + Number(y));
        }

        //alert(line.getAttribute('id'));
        /*var place = line.getAttribute('id').search(nodeid);
        //alert(place);
        if (place != -1)
        {
            if(place == 0)
            {
                line.setAttribute('x1', Number(line.getAttribute('x1')) + Number(x));
                line.setAttribute('y1', Number(line.getAttribute('y1')) + Number(y));
            }
            else
            {
                line.setAttribute('x2', Number(line.getAttribute('x2')) + Number(x));
                line.setAttribute('y2', Number(line.getAttribute('y2')) + Number(y));
            }
        }*/
    }
}

function updateDOMCoords(obj)
{
    if (obj.firstChild/*.firstChild*/.getAttribute('id') == 'element')
    {
        var coords = getCentreCoords(obj.firstChild);
        var nodeid = obj.getAttribute('id');
        var xpath = "/xfact:pattern/xfact:nodes/xfact:node[@node_id='"+nodeid+"']";
        //alert(xpath);
        var node = DOMDoc.selectSingleNode(xpath);
        //alert(node);
        //alert(x+' '+y);
        node.setAttribute('xpos', coords[0]);
        node.setAttribute('ypos', coords[1]);
        document.pattern_viewer_xform.xml_data.value = new XMLSerializer().serializeToString(DOMDoc);;
    }
}

function addCon(end)
{
    var start = object.firstChild.getAttribute('id');
    //check if connection already exists, or if start, and end points are the same
    var con = pictureDoc.getElementById(start+end);
    if (con != null)
    {
        alert('Connection already exists!');
        links.removeChild(object);
    }
    else
    {
        object.firstChild.setAttribute('id', start+end);
        object.firstChild.setAttribute('marker-end', 'url(#Triangle)');
        addConToDOM(start.substring(0, start.indexOf('*@*@*')), end);
        enterConnectionActions(start.substring(0, start.indexOf('*@*@*')), end);
    }

}

function editCon(start, end)
{
    //var start = object.getAttribute('id');
    //check if connection exists
    var con = pictureDoc.getElementById(start+'*@*@*'+end);
    if (con == null)
    {
        alert('Connection doesnt exist!');
        //links.removeChild(object);
    }
    else
    {
        //links.removeChild(object);
        enterConnectionActions(start, end);
    }

}


function addConToDOM(startid, endid)
{
    var xpath = "/xfact:pattern/xfact:nodes/xfact:node[@node_id='"+startid+"']";
    var startNode = DOMDoc.selectSingleNode(xpath);
    var partner_nodes = startNode.selectSingleNode('./xfact:partner_nodes');
    if (partner_nodes == null)
    {
        partner_nodes = createNamespaceElement(DOMDoc, 'partner_nodes', defaultNS);
        startNode.appendChild(partner_nodes);
    }
    var newPartner = createNamespaceElement(DOMDoc, 'partner_node', defaultNS);
    newPartner.setAttribute('node_ref', endid)
    var actions = createNamespaceElement(DOMDoc, 'actions', defaultNS);
    newPartner.appendChild(actions);
    partner_nodes.appendChild(newPartner);
    document.pattern_viewer_xform.xml_data.value = new XMLSerializer().serializeToString(DOMDoc);;
}

function removeCons(id)
{
    var lines = pictureDoc.getElementsByTagName('line');
    var list = new Array(lines.length);
    for (var y=0; y<lines.length; y++)
        list[y] = lines.item(y);


    for (var z=0; z<list.length; z++)
    {
        //alert('length: '+list.length);
        //alert('z: '+z);
        var line = list[z];
        //alert(line.getAttribute('id'));

        var lineID = line.getAttribute('id');
        var splitID = lineID.split('*@*@*');
        if (splitID[0] == id)
        {
            removeCon(id, splitID[1]);
        }
        else if (splitID[1] == id)
        {
            removeCon(splitID[0], id);
        }

        /*var place = line.getAttribute('id').search(id);
        //alert(place);
        if (place != -1)
        {
            if(place == 0)
            {
                //alert('start');
                var end = new String(line.getAttribute('id'));
                end = end.substr(id.length);
                //alert('startid: '+start);
                //alert('endid: '+end);
                removeCon(id, end);
            }
            else
            {
                //alert('end');
                var start = new String(line.getAttribute('id'));
                start = start.substring(0, place);
                //alert('startid: '+start);
                //alert('endid: '+end);
                removeCon(start, id);
            }
        }*/
    }
}

function removeCon(startid, endid)
{
    //alert(startid+', '+endid);
    var xpath = "/xfact:pattern/xfact:nodes/xfact:node[@node_id='"+startid+"']/xfact:partner_nodes/xfact:partner_node[@node_ref='"+endid+"']";
    //alert(xpath);
    var partner_node = DOMDoc.selectSingleNode(xpath);
    if (partner_node == null)
    {
        alert('Connection doesnt exist');
    }
    else
    {
        partner_node.parentNode.removeChild(partner_node);
        var line = pictureDoc.getElementById(startid+'*@*@*'+endid);
        //line.parentNode.removeChild(line);

        var a = line.parentNode;
        a.parentNode.removeChild(a);
    }

    document.pattern_viewer_xform.xml_data.value = new XMLSerializer().serializeToString(DOMDoc);;
}

function addNodeToDOM(x, y, id)
{
    //alert('adding node to dom');
    var nodes = DOMDoc.selectSingleNode('/xfact:pattern/xfact:nodes');
    var newNode = createNamespaceElement(DOMDoc, 'node', defaultNS);
    newNode.setAttribute('node_id', id);
    newNode.setAttribute('name', id);
    newNode.setAttribute('desc', '');
    newNode.setAttribute('type', '');
    newNode.setAttribute('runtime_instance', '');
    newNode.setAttribute('protocol', '');
    newNode.setAttribute('runtime_location', '');
    newNode.setAttribute('xpos', x);
    newNode.setAttribute('ypos', y);
    var actions = createNamespaceElement(DOMDoc, 'actions', defaultNS);
    newNode.appendChild(actions);
    var engine = createNamespaceElement(DOMDoc, 'engine', defaultNS);
    engine.setAttribute('name', '');
    engine.setAttribute('desc', '');
    engine.setAttribute('type', '');
    engine.setAttribute('runtime_instance', '');
    var logicsheet = createNamespaceElement(DOMDoc, 'logicsheet', defaultNS);
    logicsheet.setAttribute('name', '');
    logicsheet.setAttribute('desc', '');
    logicsheet.setAttribute('logicsheet_ref', '');
    engine.appendChild(logicsheet);
    var resources = createNamespaceElement(DOMDoc, 'other_resources', defaultNS);
    engine.appendChild(resources);
    newNode.appendChild(engine);
    nodes.appendChild(newNode);
    document.pattern_viewer_xform.xml_data.value = new XMLSerializer().serializeToString(DOMDoc);;
}

function removeNodeFromDOM(nodeid)
{
    var xpath = "/xfact:pattern/xfact:nodes/xfact:node[@node_id='"+nodeid+"']";
    var node = DOMDoc.selectSingleNode(xpath);
    node.parentNode.removeChild(node);
    document.pattern_viewer_xform.xml_data.value = new XMLSerializer().serializeToString(DOMDoc);;
}

function changePic()
{
    var components = pictureDoc.getElementById('components');
    components.removeChild(nodes);
    components.removeChild(links);
    links = pictureDoc.createElementNS(SVG_NS, 'g');
    links.setAttribute('id', 'links');
    components.appendChild(links);
    nodes = pictureDoc.createElementNS(SVG_NS, 'g');
    nodes.setAttribute('id', 'nodes');
    components.appendChild(nodes);

    init();
}

function showNodeDetails(mouseEvent)
{
    //alert('will move to node viewer now!!');
    if ((mode == 'deletenode') || (added == true)/*|| (mode == 'addnode')*/)
    {
        return;
    }
    if (mouseEvent.detail == 2)
    {
        if (!disabled)
        {
            if (controlsDoc == null)
            {
                PINodeClicked(mouseEvent);
            }
            else
            {
                document.pattern_viewer_xform.source_node.value = mouseEvent.target.parentNode.getAttribute('id');
                document.pattern_viewer_xform.button_action.value = 'view_node_details';
                document.pattern_viewer_xform.action.value = 'Node_Viewer.xsl';
                document.pattern_viewer_xform.controller.value = 'pattern';
                document.pattern_viewer_xform.submit();
                disabled=true;
                disableForm();
            }
        }
    }
}


function enterConnectionActions(startid, endid)
{
    if (!disabled)
    {
        //alert('will move to action selection page now!!!');
        document.pattern_viewer_xform.source_node.value = startid;
        document.pattern_viewer_xform.sink_node.value = endid;
        document.pattern_viewer_xform.action.value = 'Action_Selection.xsl';
        document.pattern_viewer_xform.button_action.value = 'new_connection';
        document.pattern_viewer_xform.controller.value = 'pattern';
        document.pattern_viewer_xform.submit();
        disabled=true;
        disableForm();
    }

}

function setPIMode(mode)
{
    PIMode = mode;
}

function PINodeClicked(mouseEvent)
{
    if (PIMode == 'details')
    {
        document.pattern_viewer_xform.source_node.value = mouseEvent.target.parentNode.getAttribute('id');
        document.pattern_viewer_xform.button_action.value = 'view_node_details';
        document.pattern_viewer_xform.action.value = 'PI_Node_Viewer.xsl';
        document.pattern_viewer_xform.controller.value = 'pattern_instance';
        document.pattern_viewer_xform.attributes.item("action").nodeValue = 'xde';
        document.pattern_viewer_xform.submit();
        disabled=true;
        disableForm();
    }
    else
    {
        var nodeid = mouseEvent.target.parentNode.getAttribute('id');
        var logicsheetEntry = DOMDoc.selectSingleNode("/xfact:pattern/xfact:nodes/xfact:node[@node_id='"+nodeid+"']/xfact:engine/xfact:logicsheet");
        if ((logicsheetEntry.getAttribute('name') == '') || (logicsheetEntry.getAttribute('logicsheet_ref') == ''))
        {
            alert('You have not yet defined a logicsheet for this node.');
        }
        else
        {
            document.rulemaker.node_id.value = nodeid;
            document.rulemaker.target = "_blank";
            //document.rulemaker.submit();
            WinManager.resolveFormTargetStart(document.rulemaker, 'RuleMaker', projectname, document.rulemaker.pattern_id.value, nodeid);
            document.rulemaker.target = "_self";
            /*disabled=true;
            disableForm();*/
        }
    }
}
